//
//  PithosPreferencesController.h
//  pithos-macos
//
// Copyright 2011-2012 GRNET S.A. All rights reserved.
//
// Redistribution and use in source and binary forms, with or
// without modification, are permitted provided that the following
// conditions are met:
// 
//   1. Redistributions of source code must retain the above
//      copyright notice, this list of conditions and the following
//      disclaimer.
// 
//   2. Redistributions in binary form must reproduce the above
//      copyright notice, this list of conditions and the following
//      disclaimer in the documentation and/or other materials
//      provided with the distribution.
// 
// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// The views and conclusions contained in the software and
// documentation are those of the authors and should not be
// interpreted as representing official policies, either expressed
// or implied, of GRNET S.A.

#import <Cocoa/Cocoa.h>
@class PithosAccount;
@class PithosEmptyNode;

@interface PithosPreferencesController : NSWindowController <NSWindowDelegate, NSOutlineViewDataSource> {
    PithosAccount *selectedPithosAccount;
    
    IBOutlet NSArrayController *accountsArrayController;
    
    BOOL accountRemoveEnable;
    
    NSString *serverURL;
    NSString *authUser;
    NSString *authToken;
    NSString *displayname;
    BOOL manual;
    BOOL loginEnable;
    BOOL loginCancelEnable;
    
    BOOL syncActive;
    BOOL syncSkipHidden;
    NSString *syncDirectoryPath;
    NSMutableDictionary *syncAccountsDictionary;
    BOOL syncApplyEnable;
    BOOL syncCancelEnable;
    IBOutlet NSOutlineView *syncAccountsOutlineView;
    PithosEmptyNode *syncAccountsMyAccountNode;
    NSMutableDictionary *syncAccountsRootFilesNodes;
    
    IBOutlet NSDictionaryController *groupsDictionaryController;
    IBOutlet NSDictionaryController *selectedGroupMembersDictionaryController;
}

@property (nonatomic, strong) PithosAccount *selectedPithosAccount;

@property (nonatomic, assign) BOOL accountRemoveEnable;

@property (nonatomic, copy) NSString *serverURL;
@property (nonatomic, copy) NSString *authUser;
@property (nonatomic, copy) NSString *authToken;
@property (nonatomic, copy) NSString *displayname;
@property (nonatomic, assign) BOOL manual;
@property (nonatomic, assign) BOOL loginEnable;
@property (nonatomic, assign) BOOL loginCancelEnable;

@property (nonatomic, assign) BOOL syncActive;
@property (nonatomic, assign) BOOL syncSkipHidden;
@property (nonatomic, copy) NSString *syncDirectoryPath;
@property (nonatomic, copy) NSMutableDictionary *syncAccountsDictionary;
@property (nonatomic, assign) BOOL syncApplyEnable;
@property (nonatomic, assign) BOOL syncCancelEnable;
@property (nonatomic, strong) NSMutableDictionary *syncAccountsRootFilesNodes;

//- (IBAction)toolbarItemSelected:(id)sender;

- (IBAction)addAccount:(id)sender;
- (IBAction)removeAccount:(id)sender;
- (IBAction)login:(id)sender;
- (IBAction)loginCancel:(id)sender;
- (IBAction)syncApply:(id)sender;
- (IBAction)syncCancel:(id)sender;
- (IBAction)syncRefresh:(id)sender;
- (IBAction)groupsApply:(id)sender;
- (IBAction)groupsRevert:(id)sender;


@end
