//
//  pithos_macosAppDelegate.h
//  pithos-macos
//
// Copyright 2011-2012 GRNET S.A. All rights reserved.
//
// Redistribution and use in source and binary forms, with or
// without modification, are permitted provided that the following
// conditions are met:
// 
//   1. Redistributions of source code must retain the above
//      copyright notice, this list of conditions and the following
//      disclaimer.
// 
//   2. Redistributions in binary form must reproduce the above
//      copyright notice, this list of conditions and the following
//      disclaimer in the documentation and/or other materials
//      provided with the distribution.
// 
// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// The views and conclusions contained in the software and
// documentation are those of the authors and should not be
// interpreted as representing official policies, either expressed
// or implied, of GRNET S.A.

#import <Cocoa/Cocoa.h>
@class PithosBrowserController;
@class PithosPreferencesController;
@class PithosAccount;

@interface pithos_macosAppDelegate : NSObject <NSApplicationDelegate> {
    PithosBrowserController *pithosBrowserController;
    PithosPreferencesController *pithosPreferencesController;
    
    BOOL alwaysNo;
    
    IBOutlet NSMenu *statusMenu;
    IBOutlet NSMenu *accountsMenu;
    IBOutlet NSMenu *lastSyncMenu;
    NSStatusItem *statusItem;
    
    LSSharedFileListRef loginItems;
    BOOL openAtLoginEnabled;
    BOOL openAtLogin;
    
    NSUserDefaults *userDefaults;
    
    BOOL activated;
    PithosAccount *currentPithosAccount;
    NSMutableArray *pithosAccounts;
    NSMutableDictionary *pithosAccountsDictionary;
    
    NSTimeInterval syncTimeInterval;
    NSTimer *syncTimer;
    PithosAccount *syncPithosAccount;

    NSTimeInterval activityFacilityTimeInterval;
    
    BOOL checkForUpdatesNotRunning;
    BOOL checkForUpdatesCalledFromMenu;
}

@property (nonatomic, readonly) PithosBrowserController *pithosBrowserController;
@property (nonatomic, readonly) PithosPreferencesController *pithosPreferencesController;
@property (nonatomic, assign) BOOL alwaysNo;
@property (nonatomic, assign) BOOL openAtLoginEnabled;
@property (nonatomic, assign) BOOL openAtLogin;
@property (nonatomic, assign) BOOL activated;
@property (nonatomic, strong) PithosAccount *currentPithosAccount;
@property (nonatomic, strong) NSMutableArray *pithosAccounts;
@property (nonatomic, readonly) NSMutableDictionary *pithosAccountsDictionary;
@property (nonatomic, strong) PithosAccount *syncPithosAccount;
@property (nonatomic, readonly) NSTimeInterval activityFacilityTimeInterval;
@property (nonatomic, assign) BOOL checkForUpdatesNotRunning;

- (void)handleAppleEvent:(NSAppleEventDescriptor *)event withReplyEvent: (NSAppleEventDescriptor *)replyEvent;
- (IBAction)showPithosBrowser:(id)sender;
- (IBAction)showPithosPreferences:(id)sender;
- (IBAction)showPithosAbout:(id)sender;
- (void)sync;
- (void)savePithosAccounts:(id)sender;
- (void)removedPithosAccount:(PithosAccount *)removedPithosAccount;
- (IBAction)menuCheckForUpdates:(NSMenuItem *)sender;

@end
